SHEBANG
# Copyright (C) @BABOLO 2008  Dec 27 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.2 2009/07/21 16:02:13 babolo Exp $

JNTROSTUP(saned,,saneddnl
,dnl
# jailup ${inclass}${suffix} dir jailname jailaddr[ uid[ gid]]
#     where jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           dir relative to ${JAILUPDIR} and ${JAILRODIR}
# installed ports/graphics/sane-backends useddnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
uid="${4:-65660}"
gid="${5:-65660}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}/sane.d"
${up_mdir} "${main_dir}" ${MTREE}
${ln} -s . "${main_dir}/usr"
${ln} -s . "${main_dir}/local"
ETCOPY(protocols resolv.conf)
${up_genlist} libexec/ ${MTREE} | ${up_libexe} "${main_dir}/libexec"
${up_genlist} libexec/ ${MTREE} | grep -v ld-elf | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"
${up_genlist} lib/sane/ ${MTREE} | ${up_shlib} "${main_dir}/lib/sane" "${PREFIX}/lib/sane"
      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
${up_acc} gr "${conf_dir}" <<- EOF
	wheel:*:0:
	operator:*:5:saned
	nogroup:*:65533:
	nobody:*:65534:
	saned:*:${gid}:
EOF

${up_acc} pwt "${conf_dir}" <<- EOF
	root:*:0:0::0:0:Charlie &:/:/dev/null/none
	nobody:*:65534:65534::0:0:Unprivileged user:/dev/null/none:/dev/null/none
	saned:*:${uid}:${gid}::0:0:SANE:/dev/null/none:/dev/null/none
EOF

${up_ponf} "${conf_dir}/xinetd" "${TEMPLATE}"
${up_genlist} sane.d/ ${MTREE}-conf | ${up_data} "${conf_dir}/sane.d/" "${PREFIX}/etc/sane.d/"
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" -f ${MTREE}-conf

${up_adc} "${JAILUPRC}" <<- EOF
#${genclass}	xinetd	${jdir}	${jailsname}	${jailsaddr}	0	${uid}	=	xinetd
EOF
      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#devfs			${main_dir}/dev	devfs	rw		0 0
	#${conf_dir}		${main_dir}/etc	nullfs	ro,noexec	0 0
EOF

${up_adc} "${STARTUPDIR}/devfs" <<- EOF
	${jdir}	scan	${inclass}${suffix}
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
